/*
  QMF analysis
*/
#include <string.h>
#include <math.h>
#include "qmf_window.h"
#include "sbr_def.h"
#include "ffmpeg_fft.h"

float __attribute__ ((aligned (16))) sbr_QmfStatesAnalysis[2*QMF_FILTER_LENGTH];
void forwardModulation (FFTContext *fft32, const float *timeIn, float *rSubband, float *iSubband);

/*!

  \brief      Performs complex-valued subband filtering.
  \return     none

*/
void sbrAnalysisFiltering (FFTContext *fft32, const float *timeIn, int timeInStride,
                           float rAnalysis[32][64], float iAnalysis[32][64],
                           float *qmf_states_buffer)
{
  int i, k;
  float __attribute__ ((aligned (16))) qmf_window_buf[640];
  float __attribute__ ((aligned (16))) syn_buffer[2*QMF_CHANNELS];

  for (i = 0; i < 32; i++) {
    __asm__ volatile(
		"xor %%rax, %%rax \n\t"
        "1: \n\t"
        "movaps   (%1, %%rax), %%xmm0 \n\t"
        "movaps %%xmm0,   (%0, %%rax) \n\t"
        "add    $16, %%rax \n\t"
		"cmp    $2304, %%rax \n\t"
        "jnz    1b \n\t"
        ::"r"(qmf_states_buffer), "r"(qmf_states_buffer+64)
		: "%rax");

      for(k = 0; k < 64; k++) {
          qmf_states_buffer[576 + k] = timeIn[(i * 64 + k)*timeInStride];
      } 

    __asm__ volatile(
		"mov $0x9f0, %%rax \n\t"
        "1: \n\t"
        "movaps   (%1,%%rax), %%xmm0 \n\t"
        "mulps    (%2,%%rax), %%xmm0 \n\t"
        "movaps %%xmm0,   (%0,%%rax) \n\t"
        "sub    $16, %%rax \n\t"
        "jge    1b \n\t"
        ::"r"(qmf_window_buf), "r"(qmf_states_buffer), "r"(sbr_qmf_64_640)
        : "%rax");

    __asm__ volatile(
		"mov $0x1f0, %%rax \n\t"
		"xor %%rsi, %%rsi \n\t"
		"1: \n\t"
		"movaps (%0, %%rsi), %%xmm7 \n\t"
		"addps 512(%0, %%rsi), %%xmm7 \n\t"
		"addps 1024(%0, %%rsi), %%xmm7 \n\t"
		"addps 1536(%0, %%rsi), %%xmm7 \n\t"
		"addps 2048(%0, %%rsi), %%xmm7 \n\t"
		"shufps $0x1b, %%xmm7, %%xmm7 \n\t"
        "movaps     %%xmm7, (%1, %%rax) \n\t"
        "add    $16, %%rsi \n\t"
        "sub    $16, %%rax \n\t"
        "jge    1b \n\t"
		::"r"(qmf_window_buf), "r"(syn_buffer)
		: "%rsi", "%rax");

    forwardModulation (fft32, syn_buffer, rAnalysis[i], iAnalysis[i]);
  }
}

