/*
  Sbr miscellaneous helper functions
*/
#include "sbr_def.h"

/* Sorting routine */
void Shellsort_int (int *in, int n)
{
  int i, j, v;
  int inc = 1;

  do {
    inc = 3 * inc + 1;
  } while (inc <= n);

  do {
    inc = inc / 3;
    for (i = inc + 1; i <= n; i++) {
      v = in[i-1];
      j = i;
      while (in[j-inc-1] > v) {
        in[j-1] = in[j-inc-1];
        j -= inc;
        if (j <= inc)
          break;
      }
      in[j-1] = v;
    }
  } while (inc > 1);
}

void crcAdvance(unsigned short *crc, unsigned long bValue, int bBits)
{
  int i;
  for (i=bBits-1; i>=0; i--) {
    unsigned short flag = (*crc) & 0x0200 ? 1:0;
    flag ^= (bValue & (1<<i) ? 1 : 0);
    (*crc)<<=1;
    if(flag) {
      (*crc) ^= 0x0233; /* CRC-10-ITU */
    }
  }
}

